/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// THE NATIVE S ISLAND:
// CREATED BY DANY:
// NOVEMBER 2007:

/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** // 
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* DEFINE THE VARIABLES FOR THE VARIATIONS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int whichVersion = rmRandInt(1,2); // THIS IS USED AS THE VARIATION: 

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************** CHOOSE WHICH NATIVE TRIBES APPEAR ON THE MAP: ******************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;

/*----------------------------------------------------------------------------------------------------------------*/		
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (rmAllocateSubCivs(3) == true)
		
    {
	
		// FIRST NATIVE:
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");
		
		// SECOND NATIVE:
		subCiv1=rmGetCivID("Maya");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Maya");
		
		// THIRD NATIVE:
		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

    }
  
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int playerTiles = 22500;
	    
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(600, 600);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // SET MAP ELEVATION PARAMETERS:
		//	rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
		//rmSetMapElevationParameters(cElevTurbulence, 0.05, 5, 0.4, 3.0); // THIS IS A FLAT TERRAIN:
		rmSetMapElevationParameters(cElevTurbulence, 0.05, 6, 0.7, 8.0); // THIS IS A HILLY TERRAIN:
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
	
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(1.0);
	    
		// SET LIGHTING:
		rmSetLightingSet("amazon");

        // SET SEA TYPE:
		rmSetSeaType("Amazon River Basin");
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("amazon grass");
	
	    // TERRAIN INITIALIZE:
		rmTerrainInitialize("amazon\ground1_ama", 5.0);
	
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	
	    // SET MAP TYPE:
		rmSetMapType("amazonia");
	    rmSetMapType("tropical");
	    rmSetMapType("water");
			
	    // SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(4.0);
  
        // SET GLOBAL RAIN:
		//rmSetGlobalRain(0.8);

	    // CHOOSE MERCS:
		chooseMercs();
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classForest");
	    rmDefineClass("natives");
		rmDefineClass("classTrees");
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
    
	// MAP EDGE CONSTRAINTS:
	int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, 0, rmGetMapXSize()-12, 0, 0, 0);
    //int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
    //int playerCloseEdgeConstraint=rmCreatePieConstraint("close edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
    
	// PLAYER CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 25.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close avoid players", classPlayer, 2.0);
	
	int mediumPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players medium", classPlayer, 15.0);
	int shortPlayerConstraint=rmCreateClassDistanceConstraint("short stay away from players", classPlayer, 5.0);
    int playerConstraintNugget = rmCreateTypeDistanceConstraint("nuggets avoid TCs", "Towncenter", 55.0);
  
	// AVOID IMPASSABLE LAND:
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
    int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 4.0);
    int avoidWater6 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 6.0);
    int avoidWater = rmCreateTerrainDistanceConstraint("avoid water further", "Land", false, 10.0);
	
	// TREES AVOIDANCE:
	int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 15.0);
	int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 8.0);
	int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 3.0);
	int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
	int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
	int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
  
    // RESOURCE AVOIDANCE:
    int avoidRandomBerries=rmCreateTypeDistanceConstraint("avoid random berries", "berrybush", 35.0);
    int extraFood=rmCreateBoxConstraint("keep extra food near river", 0, .35, 1, .65, 0.01);
    
	int avoidSilver=rmCreateTypeDistanceConstraint("stuff avoid coin", "abstractmine", 15.0);
	int avoidCloseSilver=rmCreateTypeDistanceConstraint("close avoid coin", "abstractmine", 8.0);
	int avoidVeryCloseSilver=rmCreateTypeDistanceConstraint("very close avoid coin", "abstractmine", 3.0);
	int avoidMediumSilver=rmCreateTypeDistanceConstraint("medium avoid coin", "abstractmine", 25.0);
	int avoidFarSilver=rmCreateTypeDistanceConstraint("far avoid coin", "abstractmine", 60.0);
	
	
	int mediumAvoidSilver=rmCreateTypeDistanceConstraint("medium gold avoid gold", "abstractmine", 30.0);
    
	int avoidCapybara=rmCreateTypeDistanceConstraint("avoid capybara", "capybara", 50.0);
	int avoidDeer=rmCreateTypeDistanceConstraint("avoid deer", "deer", 50.0);
	
	int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "berrybush", 20.0);
	int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 10.0);
	int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoid fruits", "berrybush", 5.0);
	int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid fruits", "berrybush", 30.0);
	int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
	int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far avoid fruits", "berrybush", 70.0);
	int avoidSuperFarFruits=rmCreateTypeDistanceConstraint("super far avoid fruits", "berrybush", 90.0);
	
	int avoidTapir=rmCreateTypeDistanceConstraint("stuff avoid tapir", "tapir", 20.0);
	int avoidCloseTapir=rmCreateTypeDistanceConstraint("close avoid tapir", "tapir", 10.0);
	int avoidVeryCloseTapir=rmCreateTypeDistanceConstraint("very close avoid tapir", "tapir", 5.0);
	int avoidMediumTapir=rmCreateTypeDistanceConstraint("medium avoid tapir", "tapir", 30.0);
	int avoidFarTapir=rmCreateTypeDistanceConstraint("far avoid tapir", "tapir", 50.0);
	int avoidVeryFarTapir=rmCreateTypeDistanceConstraint("very far avoid tapir", "tapir", 70.0);
	int avoidSuperFarTapir=rmCreateTypeDistanceConstraint("super far avoid tapir", "tapir", 90.0);
	
	int avoidNuggets=rmCreateTypeDistanceConstraint("stuff vs. nugget", "AbstractNugget", 20.0);
	int avoidCloseNuggets=rmCreateTypeDistanceConstraint("close vs. nugget", "AbstractNugget", 10.0);
	int avoidVeryCloseNuggets=rmCreateTypeDistanceConstraint("very close vs. nugget", "AbstractNugget", 5.0);
	int avoidMediumNuggets=rmCreateTypeDistanceConstraint("medium vs. nugget", "AbstractNugget", 30.0);
    int avoidFarNuggets=rmCreateTypeDistanceConstraint("far vs. nugget", "AbstractNugget", 60.0);
    
	
	int avoidNuggetMedium=rmCreateTypeDistanceConstraint("nugget vs. nugget medium", "AbstractNugget", 35.0);
	int avoidNuggetFar=rmCreateTypeDistanceConstraint("nugget vs. nugget far", "AbstractNugget", 50.0);
    	
	int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 15.0);
	int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 10.0);
    int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close vs. forest", rmClassID("classForest"), 5.0);
    
    int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 25.0);
  
	int forestConstraintShort=rmCreateClassDistanceConstraint("forest vs. forest short", rmClassID("classForest"), 10.0);
    int forestConstraintGroves=rmCreateClassDistanceConstraint("forest vs. forest for small groves", rmClassID("classForest"), 15.0);
		
	int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 4.0);
	int shortAvoidResource=rmCreateTypeDistanceConstraint("resource avoid resource short", "resource", 4.0);
	int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 12.0);
      
    // BOX CONSTRAINT:
	int topConstraint=rmCreateBoxConstraint("stay on top of map", 0, .65, 1, 1);
    int bottomConstraint=rmCreateBoxConstraint("stay on bottom of map", 0, 0, 1, .35);
    int middleConstraint=rmCreateBoxConstraint("stay in middle of map", 0, .35, 1, .65);

	// Specify true so constraint stays outside of circle (i.e. inside corners)
	// CIRCLE CONSTRAINT:
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));

	// NATIVES AVOIDANCE:
	int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 20.0);
    int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 10.0);
    int avoidVeryCloseNatives=rmCreateClassDistanceConstraint("very close avoids natives", rmClassID("natives"), 5.0);
    int avoidMediumNatives=rmCreateClassDistanceConstraint("medium avoids natives", rmClassID("natives"), 35.0);
    int avoidFarNatives=rmCreateClassDistanceConstraint("far avoids natives", rmClassID("natives"), 50.0);
    int avoidVeryFarNatives=rmCreateClassDistanceConstraint("very far avoids natives", rmClassID("natives"), 65.0);
    int avoidSuperFarNatives=rmCreateClassDistanceConstraint("super far avoids natives", rmClassID("natives"), 80.0);
    
	int shortAvoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives a little", rmClassID("natives"), 4.0);
	int farAvoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives alot", rmClassID("natives"), 80.0);

    // FISH CONSTRAINTS:
    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "FishSardine", 15.0);	
	int fishVsFish2ID=rmCreateTypeDistanceConstraint("fish v fish2", "FishBass", 15.0); 
	int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);

    // FLAG CONSTRAINTS:
    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 10.0);
	int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	int flagEdgeConstraint=rmCreatePieConstraint("flag edge of map", 0.5, 0.5, 0, rmZFractionToMeters(0.20), rmDegreesToRadians(0), rmDegreesToRadians(360));
  
    // HILL AVOIDANCE:
	int hillLand = rmCreateTerrainDistanceConstraint("hill land", "land", true, 6.0);

	// DECORATION AVOIDANCE:
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);

	// TRADE ROUTE AVOIDANCE:
	int shortAvoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route short", 5.0);
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
    int shortAvoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid trade route sockets short", "sockettraderoute", 5.0);
	int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid trade route sockets", "sockettraderoute", 11.0);
	int avoidTradeRouteSocketsFar=rmCreateTypeDistanceConstraint("avoid trade route sockets far", "sockettraderoute", 40.0);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// *********************************** DEFINE SOME OBJECTS TO BE PLACED LATER: ********************************** //
/*================================================================================================================*/
  
        // DEFINE THE STARTING DEER:
		int startDeerID=rmCreateObjectDef("Starting Deer Herds"); // THESE GOES WITH THE STARTING RESOURCES:
	    rmAddObjectDefItem(startDeerID, "deer", 7, 5.0);
	    rmSetObjectDefMinDistance(startDeerID, 25.0);
	    rmSetObjectDefMaxDistance(startDeerID, 35.0);
	    rmSetObjectDefCreateHerd(startDeerID, false);

/*----------------------------------------------------------------------------------------------------------------*/

	    // OBJECTS END:
  
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE YELLOW RIVER: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE YELLOW RIVER 1:
		
		int yellowRiver1 = -1;
	    
		yellowRiver1 = rmRiverCreate(-1, "Amazon River", 3, 3, 12, 12);
	    
		rmRiverSetConnections(yellowRiver1, 0.40, 0.80, 0.80, 0.40);
		
		rmRiverSetShallowRadius(yellowRiver1, 7);
		
		rmRiverAddShallow(yellowRiver1, 0.5);
	
        rmRiverBuild(yellowRiver1);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE YELLOW RIVER 2:
		
		int yellowRiver2 = rmRiverCreate(-1, "Amazon River", 3, 3, 12, 12);
		
		rmRiverConnectRiver(yellowRiver2, yellowRiver1, 0.0, 0.20, 0.60);
		
		rmRiverSetShallowRadius(yellowRiver2, 7);
		
		rmRiverAddShallow(yellowRiver2, 0.5);
		
		rmRiverBuild(yellowRiver2);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE YELLOW RIVER 3:
		
		int yellowRiver3 = rmRiverCreate(-1, "Amazon River", 3, 3, 12, 12);
		
		rmRiverConnectRiver(yellowRiver3, yellowRiver2, 0.0, 0.60, 0.20);
		
		rmRiverSetShallowRadius(yellowRiver3, 7);
		
		rmRiverAddShallow(yellowRiver3, 0.5);
		
		rmRiverBuild(yellowRiver3);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE YELLOW RIVER 4:
		
		int yellowRiver4 = rmRiverCreate(-1, "Amazon River", 3, 3, 12, 12);
		
		rmRiverConnectRiver(yellowRiver4, yellowRiver3, 0.0, 0.80, 0.40);
		
		rmRiverSetShallowRadius(yellowRiver4, 7);
		
		rmRiverAddShallow(yellowRiver4, 0.5);
		
		rmRiverBuild(yellowRiver4);		
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// **************************** DEFINE AND PLACE THE TRADE ROUTES AND THE SOCKETS: ****************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ******************** PAINT THE TRADE ROUTE RIVER CROSSINGS SO THEY DON'T LOOK TOO SILLY: ********************* //
// ********************************** PAINT THE NW AND SW IN NON-WEIRD GAMES: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ********************** SET UP SOME INVISIBLE AREAS TO AID IN NATIVE PLACEMENT ON ISLANDS: ******************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
        // THE NORTH ISLAND:
		int northIslandID = rmCreateArea("north island");
        rmSetAreaLocation(northIslandID, 0.15, 0.85); 
        rmSetAreaWarnFailure(northIslandID, false);
		rmSetAreaSize(northIslandID, 0.065, 0.065);
        rmSetAreaCoherence(northIslandID, 1.0);
		//rmSetAreaMix(northIslandID, "rockies_snow");
        rmAddAreaConstraint(northIslandID, avoidImpassableLand);
        rmBuildArea(northIslandID);
		
/*----------------------------------------------------------------------------------------------------------------*/
  
        // THE SOUTH ISLAND:
		int southIslandID = rmCreateArea("south island");
        rmSetAreaLocation(southIslandID, 0.85, 0.15); 
        rmSetAreaWarnFailure(southIslandID, false);
		rmSetAreaSize(southIslandID, 0.065, 0.065);
        rmSetAreaCoherence(southIslandID, 1.0);
		//rmSetAreaMix(southIslandID, "rockies_snow");
        rmAddAreaConstraint(southIslandID, avoidImpassableLand);
        rmBuildArea(southIslandID);
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        // THE DRY ISLAND:
		int dryIslandID = rmCreateArea("dry island");
        rmSetAreaLocation(dryIslandID, 0.5, 0.5); 
        rmSetAreaWarnFailure(dryIslandID, false);
        rmSetAreaSize(dryIslandID, 0.10, 0.10);
        rmSetAreaCoherence(dryIslandID, 1.0);
		//rmSetAreaMix(dryIslandID, "texas_dirt");
        rmAddAreaConstraint(dryIslandID, avoidImpassableLand);
        rmBuildArea(dryIslandID);
				
/*----------------------------------------------------------------------------------------------------------------*/		
  
        // TOP ISLAND:
		int topIslandID = rmCreateArea("top island");
        rmSetAreaLocation(topIslandID, 0.85, 0.85); 
        rmSetAreaWarnFailure(topIslandID, false);
		rmSetAreaSize(topIslandID, 0.188, 0.188);
        rmSetAreaCoherence(topIslandID, 1.0);
		//rmSetAreaMix(topIslandID, "rockies_grass");
        rmAddAreaConstraint(topIslandID, avoidImpassableLand);
		//AddAreaConstraint(topIslandID, playerCloseConstraint);
        //rmAddAreaConstraint(topIslandID, topConstraint);  
        rmBuildArea(topIslandID);
		
/*----------------------------------------------------------------------------------------------------------------*/
  
        // THE BOTTOM ISLAND:
		int bottomIslandID = rmCreateArea("bottom island");
        rmSetAreaLocation(bottomIslandID, 0.15, 0.15); 
        rmSetAreaWarnFailure(bottomIslandID, false);
        rmSetAreaSize(bottomIslandID, 0.187, 0.187);
        rmSetAreaCoherence(bottomIslandID, 1.0);
		//rmSetAreaMix(bottomIslandID, "rockies_grass");
        rmAddAreaConstraint(bottomIslandID, avoidImpassableLand);
        //rmAddAreaConstraint(bottomIslandID, bottomConstraint);  
        rmBuildArea(bottomIslandID);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// *************************************** SET UP THE PLAYER LOCATIONS: ***************************************** // 
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		
		float teamStartLoc = rmRandFloat(0, 1);
		
/*----------------------------------------------------------------------------------------------------------------*/  
  
        if (teamStartLoc > 0.5)
	{
        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.65, 0.85, 0.85, 0.65, 0.0, 0.0);
          
        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.35, 0.15, 0.15, 0.35, 0.0, 0.0);                
    }
        else
	{
        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.65, 0.85, 0.85, 0.65, 0.0, 0.0);
          
        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.35, 0.15, 0.15, 0.35, 0.0, 0.0);                   
    }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ******************************************* SET THE PLAYER AREAS: ******************************************** //  
/*================================================================================================================*/
  
        float playerFraction=rmAreaTilesToFraction(3000);
        
		for(i=1; <cNumberPlayers) 
	{
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer); 
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); // All CONSTRAINTS REMOVED BY ME:
        //rmAddAreaConstraint(id, playerEdgeConstraint); 
        //rmAddAreaConstraint(id, avoidImpassableLand);
        //rmAddAreaConstraint(id, avoidTradeRouteSockets);
        //rmAddAreaConstraint(id, avoidTradeRoute);
        //rmAddAreaConstraint(id, avoidWater6);
        
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i); // IT WAS ADDED BY ME:
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
    }
  	    // BUILD THE AREAS:
        rmBuildAllAreas();
  
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************** SET UP SOME INVISIBLE AREAS TO AID IN NATIVE PLACEMENT ON ISLANDS: ******************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("Aztecs"))
	{  
		int AztecsVillageAID = -1;
		AztecsVillageAID = rmCreateGrouping("Aztecs village A", "native aztec village 1");
		rmSetGroupingMinDistance(AztecsVillageAID, 0.0);
		rmSetGroupingMaxDistance(AztecsVillageAID, 0.0);
		rmAddGroupingToClass(AztecsVillageAID, rmClassID("natives"));
		rmAddGroupingConstraint(AztecsVillageAID, avoidNatives);
		rmPlaceGroupingAtLoc(AztecsVillageAID, 0, 0.4, 0.6);
	} 

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("Maya"))
	{  
		int MayaVillageBID = -1;
		MayaVillageBID = rmCreateGrouping("Maya village B", "native Maya village 1");
		rmSetGroupingMinDistance(MayaVillageBID, 0.0);
		rmSetGroupingMaxDistance(MayaVillageBID, 0.0);
		rmAddGroupingToClass(MayaVillageBID, rmClassID("natives"));
		rmAddGroupingConstraint(MayaVillageBID, avoidNatives);
		rmPlaceGroupingAtLoc(MayaVillageBID, 0, 0.5, 0.5);
	} 

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("Aztecs"))
	{  
		int AztecsVillageCID = -1;
		AztecsVillageCID = rmCreateGrouping("Aztecs village C", "native aztec village 1");
		rmSetGroupingMinDistance(AztecsVillageCID, 0.0);
		rmSetGroupingMaxDistance(AztecsVillageCID, 0.0);
		rmAddGroupingToClass(AztecsVillageCID, rmClassID("natives"));
		rmAddGroupingConstraint(AztecsVillageCID, avoidNatives);
		rmPlaceGroupingAtLoc(AztecsVillageCID, 0, 0.6, 0.4);
	}   	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// **************** DEFINE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: ***************** //  
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
  
        int TCfloat = -1;
	    if (cNumberNonGaiaPlayers <= 2)
		TCfloat = 0;
	    else 
		TCfloat = 0;
		
/*---------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
  
	    if (rmGetNomadStart())
	{
        rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);
    }
        else	
    {
        rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
    }
    
	    rmSetObjectDefMinDistance(startingTCID, 0);
	    rmSetObjectDefMaxDistance(startingTCID, TCfloat);
	    rmAddObjectDefConstraint(startingTCID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(startingTCID, shortAvoidTradeRoute);
	    rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSockets);
        rmAddObjectDefConstraint(startingTCID, avoidWater6);
        rmAddObjectDefConstraint(startingTCID, avoidNatives);
	    rmAddObjectDefToClass(startingTCID, rmClassID("player"));
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE STARTING TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "treeamazon", 12, 8.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 33);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 38);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	    rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);
		
/*----------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE STARTING BERRIES:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 4, 4.0);
	    rmSetObjectDefMinDistance(StartBerriesID, 14);
	    rmSetObjectDefMaxDistance(StartBerriesID, 18);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartResource);
	    rmAddObjectDefConstraint(StartBerriesID, shortAvoidImpassableLand);
	    rmAddObjectDefConstraint(StartBerriesID, avoidNatives);
	    rmAddObjectDefConstraint(StartBerriesID, avoidTradeRoute);
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        // DEFINE THE STARTING SILVER:
		int startSilverID = rmCreateObjectDef("player silver");
	    rmAddObjectDefItem(startSilverID, "mine", 1, 0);
	    rmAddObjectDefConstraint(startSilverID, shortAvoidTradeRoute);
	    rmSetObjectDefMinDistance(startSilverID, 18.0);
	    rmSetObjectDefMaxDistance(startSilverID, 24.0);
	    rmAddObjectDefConstraint(startSilverID, avoidAll);
	    rmAddObjectDefConstraint(startSilverID, avoidImpassableLand);
        rmAddObjectDefConstraint(startSilverID, avoidNatives);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 6.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidResource);
	    rmAddObjectDefConstraint(startingUnits, avoidImpassableLand);
	    rmAddObjectDefConstraint(startingUnits, avoidWater);
		
/*----------------------------------------------------------------------------------------------------------------*/
  
        // DEFINE PLAYER CRATE:
		int playerCrateID=rmCreateObjectDef("bonus starting crates");
        rmAddObjectDefItem(playerCrateID, "crateOfFood", 2, 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfWood", 1, 0.0);
        rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 0.0);
        rmSetObjectDefMinDistance(playerCrateID, 10);
        rmSetObjectDefMaxDistance(playerCrateID, 12);
	    rmAddObjectDefConstraint(playerCrateID, avoidAll);
        rmAddObjectDefConstraint(playerCrateID, shortAvoidImpassableLand);
		
/*----------------------------------------------------------------------------------------------------------------*/
		
        //DEFINE PLAYER NUGGET:
        int playerNuggetID=rmCreateObjectDef("player nugget");
        rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
        rmSetObjectDefMinDistance(playerNuggetID, 28.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
        rmAddObjectDefConstraint(playerNuggetID, avoidAll);
        rmAddObjectDefConstraint(playerNuggetID, shortAvoidImpassableLand);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE WATER SPAWN POINT:
		int waterSpawnPointID = 0;
	    
/*---------------------------------------------------------------------------------------------------------------*/		
		
		// CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ***************** PLACE THE STARTING TCID AND THE STARTING UNITS AND THE STARTING RESOURCES: ***************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    for(i=1; < cNumberPlayers) 
		
{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));

        // PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

/*----------------------------------------------------------------------------------------------------------------*/
		
        // THE WET CRATES:
		// PLACE THE PLAYER CRATE:
        if (rmGetNomadStart() == false && whichVersion == 1)
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));

/*----------------------------------------------------------------------------------------------------------------*/		
		
        // PLACE THE STARTING SILVER:
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
		
		// PLACE THE STARTING BERRIES:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        
		// PLACE THE STARTING DEER:
		rmPlaceObjectDefAtLoc(startDeerID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
    
		// PLACE THE STARTING TREE:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
    	rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
    	rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
    	
        // PLACE THE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLocation)), rmZMetersToFraction(xsVectorGetZ(TCLocation)));
 
/*----------------------------------------------------------------------------------------------------------------*/
		
            // HC WATER SPAWNS WHEN WET:
        waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
        rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 10.0);
        rmAddClosestPointConstraint(flagVsFlag);
        rmAddClosestPointConstraint(flagLand);
        rmAddClosestPointConstraint(flagEdgeConstraint);
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));
        rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
      
        // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
   
}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SILVER MINES:	************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int coinID = rmCreateObjectDef("The Gold Coin");
        rmAddObjectDefItem(coinID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(coinID, 0.0);
        rmSetObjectDefMaxDistance(coinID, 0.0);
        //rmAddObjectDefConstraint(coinID, playerCloseConstraint);
		
		rmPlaceObjectDefAtLoc(coinID, 0, 0.4, 0.965);
		rmPlaceObjectDefAtLoc(coinID, 0, 0.965, 0.4);
		rmPlaceObjectDefAtLoc(coinID, 0, 0.0315, 0.595);
		rmPlaceObjectDefAtLoc(coinID, 0, 0.595, 0.0315);
		
		int chevreuilID = rmCreateObjectDef("Chevreuil");
        rmAddObjectDefItem(chevreuilID, "deer", 9, 4.0);
        rmSetObjectDefMinDistance(chevreuilID, 0.0);
        rmSetObjectDefMaxDistance(chevreuilID, 0.0);
        //rmAddObjectDefConstraint(chevreuilID, playerCloseConstraint);
		
		rmPlaceObjectDefAtLoc(chevreuilID, 0, 0.4, 0.925);
		rmPlaceObjectDefAtLoc(chevreuilID, 0, 0.925, 0.4);
		rmPlaceObjectDefAtLoc(chevreuilID, 0, 0.0675, 0.60);
		rmPlaceObjectDefAtLoc(chevreuilID, 0, 0.60, 0.0675);
		
		int murierID = rmCreateObjectDef("murier");
        rmAddObjectDefItem(murierID, "berrybush", 5, 3.0);
        rmSetObjectDefMinDistance(murierID, 0.0);
        rmSetObjectDefMaxDistance(murierID, 0.0);
        //rmAddObjectDefConstraint(murierID, playerCloseConstraint);
		
		rmPlaceObjectDefAtLoc(murierID, 0, 0.4, 0.875);
		rmPlaceObjectDefAtLoc(murierID, 0, 0.875, 0.4);
		rmPlaceObjectDefAtLoc(murierID, 0, 0.0997, 0.60);
		rmPlaceObjectDefAtLoc(murierID, 0, 0.5975, 0.0997);


/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FORESTS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
  
	    if (cNumberNonGaiaPlayers <= 2)
		int numTries = 6*cNumberNonGaiaPlayers;
        else
        numTries = 3*cNumberNonGaiaPlayers;
  
	    int failCount=0;
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
	    // THE TOP ISLAND FOREST:
		for (i=0; <numTries)	
		
	{  
	
        int forestID=rmCreateArea("foresta"+i, topIslandID);
        rmSetAreaWarnFailure(forestID, false);
        rmSetAreaSize(forestID, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forestID, "amazon rain forest");
        rmAddAreaToClass(forestID, rmClassID("classForest")); 
        rmSetAreaForestDensity(forestID, 0.6);
        rmSetAreaForestClumpiness(forestID, 0.5);
        rmSetAreaForestUnderbrush(forestID, 0.1);
        rmSetAreaCoherence(forestID, 0.4);
        rmAddAreaConstraint(forestID, avoidImpassableLand);
        rmAddAreaConstraint(forestID, forestMediumConstraint);
        rmAddAreaConstraint(forestID, playerCloseConstraint); 
		rmAddAreaConstraint(forestID, playerEdgeConstraint); 
        rmBuildArea(forestID);
		
    } 
	
/*----------------------------------------------------------------------------------------------------------------*/	
	
        // THE BOTTOM ISLAND FOREST:
		
        for (i=0; <numTries)
		
	{  
	
        int forestID2=rmCreateArea("forestb"+i, bottomIslandID);
        rmSetAreaWarnFailure(forestID2, false);
        rmSetAreaSize(forestID2, rmAreaTilesToFraction(100), rmAreaTilesToFraction(150));
        rmSetAreaForestType(forestID2, "amazon rain forest");
        rmAddAreaToClass(forestID2, rmClassID("classForest")); 
        rmSetAreaForestDensity(forestID2, 0.5);
        rmSetAreaForestClumpiness(forestID2, 0.4);		
        rmSetAreaForestUnderbrush(forestID2, 0.1);
        rmSetAreaCoherence(forestID2, 0.4);
        rmAddAreaConstraint(forestID2, avoidImpassableLand);
        rmAddAreaConstraint(forestID2, forestMediumConstraint);
        rmAddAreaConstraint(forestID2, playerCloseConstraint); 
        rmAddAreaConstraint(forestID2, playerEdgeConstraint);
        rmBuildArea(forestID2);
		
    } 
  
/*----------------------------------------------------------------------------------------------------------------*/
		
		if (cNumberNonGaiaPlayers <= 2)
		numTries = 3.0*cNumberNonGaiaPlayers;
        else
        numTries = 1.5*cNumberNonGaiaPlayers;
  
	    failCount=0;
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE WEST ISLAND FOREST:
		
		for (i=0; <numTries)
		
	{  
	
        int forestID3=rmCreateArea("forestc"+i, northIslandID);
        rmSetAreaWarnFailure(forestID3, false);
        rmSetAreaSize(forestID3, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forestID3, "amazon rain forest");
        rmAddAreaToClass(forestID3, rmClassID("classForest")); 
        rmSetAreaForestDensity(forestID3, 0.5);
        rmSetAreaForestClumpiness(forestID3, 0.4);		
        rmSetAreaForestUnderbrush(forestID3, 0.1);
        rmSetAreaCoherence(forestID3, 0.4);
        rmAddAreaConstraint(forestID3, avoidImpassableLand);
        rmAddAreaConstraint(forestID3, forestMediumConstraint);
        rmAddAreaConstraint(forestID3, playerCloseConstraint);
        rmAddAreaConstraint(forestID3, playerEdgeConstraint);		
        rmBuildArea(forestID3);
		
    } 
	
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EAST ISLAND FOREST:
		
		for (i=0; <numTries)
		
	{  
	
        int forestID4=rmCreateArea("forestd"+i, southIslandID);
        rmSetAreaWarnFailure(forestID4, false);
        rmSetAreaSize(forestID4, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forestID4, "amazon rain forest");
        rmAddAreaToClass(forestID4, rmClassID("classForest")); 
        rmSetAreaForestDensity(forestID4, 0.5);
        rmSetAreaForestClumpiness(forestID4, 0.4);		
        rmSetAreaForestUnderbrush(forestID4, 0.1);
        rmSetAreaCoherence(forestID4, 0.4);
        rmAddAreaConstraint(forestID4, avoidImpassableLand);
        rmAddAreaConstraint(forestID4, forestMediumConstraint);
        rmAddAreaConstraint(forestID4, playerCloseConstraint);
        rmAddAreaConstraint(forestID4, playerEdgeConstraint);		
        rmBuildArea(forestID4);
		
    } 

/*----------------------------------------------------------------------------------------------------------------*/

        if (cNumberNonGaiaPlayers <= 2)
		numTries = 4.0*cNumberNonGaiaPlayers;
        else
        numTries = 2.0*cNumberNonGaiaPlayers;
  
	    failCount=0;

/*---------------------------------------------------------------------------------------------------------------*/		

        // THE DRY ISLAND FOREST:
		
		for (i=0; <numTries)
		
	{  
	
        int forestID5=rmCreateArea("foreste"+i, dryIslandID);
        rmSetAreaWarnFailure(forestID5, false);
        rmSetAreaSize(forestID5, rmAreaTilesToFraction(175), rmAreaTilesToFraction(250));
        rmSetAreaForestType(forestID5, "amazon rain forest");
        rmAddAreaToClass(forestID5, rmClassID("classForest")); 
        rmSetAreaForestDensity(forestID5, 0.5);
        rmSetAreaForestClumpiness(forestID5, 0.4);		
        rmSetAreaForestUnderbrush(forestID5, 0.1);
        rmSetAreaCoherence(forestID5, 0.4);
        rmAddAreaConstraint(forestID5, avoidImpassableLand);
		rmAddAreaConstraint(forestID5, avoidCloseNatives);
        rmAddAreaConstraint(forestID5, forestMediumConstraint);
        rmAddAreaConstraint(forestID5, playerCloseConstraint);
        rmAddAreaConstraint(forestID5, playerEdgeConstraint);		
        rmBuildArea(forestID5);
		
    } 	

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE TOP ISLAND EASY NUGGET:
		
		int nugget1= rmCreateObjectDef("nugget easy 1" ); 
        rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(1, 2);
        rmSetObjectDefMinDistance(nugget1, 0.0);
        rmSetObjectDefMaxDistance(nugget1, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nugget1, avoidImpassableLand);
        rmAddObjectDefConstraint(nugget1, avoidFarNuggets);
        rmAddObjectDefConstraint(nugget1, forestConstraint);
        rmAddObjectDefConstraint(nugget1, playerCloseConstraint);
        rmAddObjectDefConstraint(nugget1, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(nugget1, 0, topIslandID, 4.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(nugget1, 0, topIslandID, 2.0*cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/
        
		// THE BOTTOM ISLAND EASY NUGGET:
		
		int nugget2= rmCreateObjectDef("nugget easy 2" ); 
        rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(1, 2);
        rmSetObjectDefMinDistance(nugget2, 0.0);
        rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nugget2, avoidImpassableLand);
        rmAddObjectDefConstraint(nugget2, avoidFarNuggets);
        rmAddObjectDefConstraint(nugget2, forestConstraint);
        rmAddObjectDefConstraint(nugget2, playerCloseConstraint);
        rmAddObjectDefConstraint(nugget2, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(nugget2, 0, bottomIslandID, 4.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(nugget2, 0, bottomIslandID, 2.0*cNumberNonGaiaPlayers);	

/*---------------------------------------------------------------------------------------------------------------*/

        // THE NORTH ISLAND EASY NUGGET:
		
		int nugget3= rmCreateObjectDef("nugget easy 3" ); 
        rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(1, 2);
        rmSetObjectDefMinDistance(nugget3, 0.0);
        rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nugget3, avoidImpassableLand);
        rmAddObjectDefConstraint(nugget3, avoidFarNuggets);
        rmAddObjectDefConstraint(nugget3, forestConstraint);
        rmAddObjectDefConstraint(nugget3, playerCloseConstraint);
        rmAddObjectDefConstraint(nugget3, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(nugget3, 0, northIslandID, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(nugget3, 0, northIslandID, 1.0*cNumberNonGaiaPlayers);

/*---------------------------------------------------------------------------------------------------------------*/

        // THE SOUTH ISLAND EASY NUGGET:
		
		int nugget4= rmCreateObjectDef("nugget easy 4" ); 
        rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(1, 2);
        rmSetObjectDefMinDistance(nugget4, 0.0);
        rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nugget4, avoidImpassableLand);
        rmAddObjectDefConstraint(nugget4, avoidFarNuggets);
        rmAddObjectDefConstraint(nugget4, forestConstraint);
        rmAddObjectDefConstraint(nugget4, playerCloseConstraint);
        rmAddObjectDefConstraint(nugget4, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(nugget4, 0, southIslandID, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(nugget4, 0, southIslandID, 1.0*cNumberNonGaiaPlayers);

/*---------------------------------------------------------------------------------------------------------------*/

        // THE DRY ISLAND EASY NUGGET:
		
		int nugget5= rmCreateObjectDef("nugget easy 5" ); 
        rmAddObjectDefItem(nugget5, "Nugget", 1, 0.0);
        rmSetNuggetDifficulty(1, 2);
        rmSetObjectDefMinDistance(nugget5, 0.0);
        rmSetObjectDefMaxDistance(nugget5, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(nugget5, avoidImpassableLand);
        rmAddObjectDefConstraint(nugget5, avoidFarNuggets);
		rmAddObjectDefConstraint(nugget5, avoidCloseNatives);
        rmAddObjectDefConstraint(nugget5, forestConstraint);
        rmAddObjectDefConstraint(nugget5, playerCloseConstraint);
        rmAddObjectDefConstraint(nugget5, playerEdgeConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(nugget5, 0, dryIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(nugget5, 0, dryIslandID, 1.5*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE SILVER MINES: ************************************* //
/*================================================================================================================*/        
		
		// THE SILVER MINES TOP:
		
		int silver1ID = rmCreateObjectDef("silver mines top");
	    rmAddObjectDefItem(silver1ID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(silver1ID, 0.0);
	    rmSetObjectDefMaxDistance(silver1ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silver1ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(silver1ID, avoidFarSilver);
		rmAddObjectDefConstraint(silver1ID, avoidNuggets);
	    rmAddObjectDefConstraint(silver1ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silver1ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(silver1ID, forestCloseConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(silver1ID, 0, topIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(silver1ID, 0, topIslandID, 1.5*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SILVER MINES BOTTOM:
		
		int silver2ID = rmCreateObjectDef("silver mines bottom");
	    rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(silver2ID, 0.0);
	    rmSetObjectDefMaxDistance(silver2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silver2ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(silver2ID, avoidFarSilver);
		rmAddObjectDefConstraint(silver2ID, avoidNuggets);
	    rmAddObjectDefConstraint(silver2ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silver2ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(silver2ID, forestCloseConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(silver2ID, 0, bottomIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(silver2ID, 0, bottomIslandID, 1.5*cNumberNonGaiaPlayers);

/*---------------------------------------------------------------------------------------------------------------*/

        // THE SILVER MINES NORTH:
		
		int silver3ID = rmCreateObjectDef("silver mines north");
	    rmAddObjectDefItem(silver3ID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(silver3ID, 0.0);
	    rmSetObjectDefMaxDistance(silver3ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silver3ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(silver3ID, avoidMediumSilver);
		rmAddObjectDefConstraint(silver3ID, avoidNuggets);
	    rmAddObjectDefConstraint(silver3ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silver3ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(silver3ID, forestCloseConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(silver3ID, 0, northIslandID, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(silver3ID, 0, northIslandID, 1.0*cNumberNonGaiaPlayers);	

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SILVER MINES SOUTH:
		
		int silver4ID = rmCreateObjectDef("silver mines south");
	    rmAddObjectDefItem(silver4ID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(silver4ID, 0.0);
	    rmSetObjectDefMaxDistance(silver4ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silver4ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(silver4ID, avoidMediumSilver);
		rmAddObjectDefConstraint(silver4ID, avoidNuggets);
	    rmAddObjectDefConstraint(silver4ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silver4ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(silver4ID, forestCloseConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(silver4ID, 0, southIslandID, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(silver4ID, 0, southIslandID, 1.0*cNumberNonGaiaPlayers);	
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SILVER MINES DRY:
		
		int silver5ID = rmCreateObjectDef("silver mines dry");
	    rmAddObjectDefItem(silver5ID, "mine", 1, 0.0);
	    rmSetObjectDefMinDistance(silver5ID, 0.0);
	    rmSetObjectDefMaxDistance(silver5ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silver5ID, avoidImpassableLand);
	    rmAddObjectDefConstraint(silver5ID, avoidMediumSilver);
		rmAddObjectDefConstraint(silver5ID, avoidNuggets);
		rmAddObjectDefConstraint(silver5ID, avoidCloseNatives);
	    rmAddObjectDefConstraint(silver5ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silver5ID, playerEdgeConstraint);
        rmAddObjectDefConstraint(silver5ID, forestCloseConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(silver5ID, 0, dryIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(silver5ID, 0, dryIslandID, 1.5*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE TAPIR: ***************************************** //
/*================================================================================================================*/
		
        // THE TOP ISLAND TAPIR HERDS:
        
		int tapirCount = rmRandInt(3,6);

		int tapirID=rmCreateObjectDef("The Top Island Tapir Herds");
        rmAddObjectDefItem(tapirID, "tapir", tapirCount, 2.0);
        rmSetObjectDefMinDistance(tapirID, 0.0);
        rmSetObjectDefMaxDistance(tapirID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(tapirID, avoidFarTapir);
        rmAddObjectDefConstraint(tapirID, avoidImpassableLand);
		rmAddObjectDefConstraint(tapirID, avoidCloseSilver);
		rmAddObjectDefConstraint(tapirID, avoidCloseNuggets);
		rmAddObjectDefConstraint(tapirID, playerCloseConstraint);
		rmAddObjectDefConstraint(tapirID, playerEdgeConstraint);
		rmAddObjectDefConstraint(tapirID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(tapirID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(tapirID, 0, topIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(tapirID, 0, topIslandID, 1.5*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE BOTTOM ISLAND TAPIR HERDS:
        
		tapirCount = rmRandInt(3,6);

		int tapir2ID=rmCreateObjectDef("The Bottom Island Tapir Herds");
        rmAddObjectDefItem(tapir2ID, "tapir", tapirCount, 2.0);
        rmSetObjectDefMinDistance(tapir2ID, 0.0);
        rmSetObjectDefMaxDistance(tapir2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(tapir2ID, avoidFarTapir);
        rmAddObjectDefConstraint(tapir2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(tapir2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(tapir2ID, avoidCloseNuggets);
		rmAddObjectDefConstraint(tapir2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(tapir2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(tapir2ID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(tapir2ID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(tapir2ID, 0, bottomIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(tapir2ID, 0, bottomIslandID, 1.5*cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE NORTH ISLAND TAPIR HERDS:
        
		tapirCount = rmRandInt(3,6);

		int tapir3ID=rmCreateObjectDef("The North Island Tapir Herds");
        rmAddObjectDefItem(tapir3ID, "tapir", tapirCount, 2.0);
        rmSetObjectDefMinDistance(tapir3ID, 0.0);
        rmSetObjectDefMaxDistance(tapir3ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(tapir3ID, avoidFarTapir);
        rmAddObjectDefConstraint(tapir3ID, avoidImpassableLand);
		rmAddObjectDefConstraint(tapir3ID, avoidCloseSilver);
		rmAddObjectDefConstraint(tapir3ID, avoidCloseNuggets);
		rmAddObjectDefConstraint(tapir3ID, playerCloseConstraint);
		rmAddObjectDefConstraint(tapir3ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(tapir3ID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(tapir3ID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(tapir3ID, 0, northIslandID, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(tapir3ID, 0, northIslandID, 1.0*cNumberNonGaiaPlayers);	

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTH ISLAND TAPIR HERDS:
        
		tapirCount = rmRandInt(3,6);

		int tapir4ID=rmCreateObjectDef("The South Island Tapir Herds");
        rmAddObjectDefItem(tapir4ID, "tapir", tapirCount, 2.0);
        rmSetObjectDefMinDistance(tapir4ID, 0.0);
        rmSetObjectDefMaxDistance(tapir4ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(tapir4ID, avoidFarTapir);
        rmAddObjectDefConstraint(tapir4ID, avoidImpassableLand);
		rmAddObjectDefConstraint(tapir4ID, avoidCloseSilver);
		rmAddObjectDefConstraint(tapir4ID, avoidCloseNuggets);
		rmAddObjectDefConstraint(tapir4ID, playerCloseConstraint);
		rmAddObjectDefConstraint(tapir4ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(tapir4ID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(tapir4ID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(tapir4ID, 0, southIslandID, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(tapir4ID, 0, southIslandID, 1.0*cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE DRY ISLAND TAPIR HERDS:
        
		tapirCount = rmRandInt(3,6);

		int tapir5ID=rmCreateObjectDef("The Dry Island Tapir Herds");
        rmAddObjectDefItem(tapir5ID, "tapir", tapirCount, 2.0);
        rmSetObjectDefMinDistance(tapir5ID, 0.0);
        rmSetObjectDefMaxDistance(tapir5ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(tapir5ID, avoidFarTapir);
		rmAddObjectDefConstraint(tapir5ID, avoidCloseNatives);
        rmAddObjectDefConstraint(tapir5ID, avoidImpassableLand);
		rmAddObjectDefConstraint(tapir5ID, avoidCloseSilver);
		rmAddObjectDefConstraint(tapir5ID, avoidCloseNuggets);
		rmAddObjectDefConstraint(tapir5ID, playerCloseConstraint);
		rmAddObjectDefConstraint(tapir5ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(tapir5ID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(tapir5ID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(tapir5ID, 0, dryIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(tapir5ID, 0, dryIslandID, 1.5*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/		
	
        // THE TOP ISLAND BERRYBUSH:
        
		int fruitsCount = rmRandInt(3,6);

		int fruitsID=rmCreateObjectDef("The Top Island Berrybush");
        rmAddObjectDefItem(fruitsID, "berrybush", fruitsCount, 3.0);
        rmSetObjectDefMinDistance(fruitsID, 0.0);
        rmSetObjectDefMaxDistance(fruitsID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fruitsID, avoidFarFruits);
        rmAddObjectDefConstraint(fruitsID, avoidCloseTapir);
        rmAddObjectDefConstraint(fruitsID, avoidImpassableLand);
		rmAddObjectDefConstraint(fruitsID, avoidCloseSilver);
		rmAddObjectDefConstraint(fruitsID, avoidCloseNuggets);
		rmAddObjectDefConstraint(fruitsID, playerCloseConstraint);
		rmAddObjectDefConstraint(fruitsID, playerEdgeConstraint);
		rmAddObjectDefConstraint(fruitsID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(fruitsID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(fruitsID, 0, topIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(fruitsID, 0, topIslandID, 1.5*cNumberNonGaiaPlayers);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE BOTTOM ISLAND BERRYBUSH:
        
		fruitsCount = rmRandInt(3,6);

		int fruits2ID=rmCreateObjectDef("The Bottom Island Berrybush");
        rmAddObjectDefItem(fruits2ID, "berrybush", fruitsCount, 3.0);
        rmSetObjectDefMinDistance(fruits2ID, 0.0);
        rmSetObjectDefMaxDistance(fruits2ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fruits2ID, avoidFarFruits);
        rmAddObjectDefConstraint(fruits2ID, avoidCloseTapir);
        rmAddObjectDefConstraint(fruits2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(fruits2ID, avoidCloseSilver);
		rmAddObjectDefConstraint(fruits2ID, avoidCloseNuggets);
		rmAddObjectDefConstraint(fruits2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(fruits2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(fruits2ID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(fruits2ID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(fruits2ID, 0, bottomIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(fruits2ID, 0, bottomIslandID, 1.5*cNumberNonGaiaPlayers);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE NORTH ISLAND BERRYBUSH:
        
		fruitsCount = rmRandInt(3,6);

		int fruits3ID=rmCreateObjectDef("The North Island Berrybush");
        rmAddObjectDefItem(fruits3ID, "berrybush", fruitsCount, 3.0);
        rmSetObjectDefMinDistance(fruits3ID, 0.0);
        rmSetObjectDefMaxDistance(fruits3ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fruits3ID, avoidFarFruits);
        rmAddObjectDefConstraint(fruits3ID, avoidCloseTapir);
        rmAddObjectDefConstraint(fruits3ID, avoidImpassableLand);
		rmAddObjectDefConstraint(fruits3ID, avoidCloseSilver);
		rmAddObjectDefConstraint(fruits3ID, avoidCloseNuggets);
		rmAddObjectDefConstraint(fruits3ID, playerCloseConstraint);
		rmAddObjectDefConstraint(fruits3ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(fruits3ID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(fruits3ID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(fruits3ID, 0, northIslandID, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(fruits3ID, 0, northIslandID, 1.0*cNumberNonGaiaPlayers);	

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTH ISLAND BERRYBUSH:
        
		fruitsCount = rmRandInt(3,6);

		int fruits4ID=rmCreateObjectDef("The South Island Berrybush");
        rmAddObjectDefItem(fruits4ID, "berrybush", fruitsCount, 3.0);
        rmSetObjectDefMinDistance(fruits4ID, 0.0);
        rmSetObjectDefMaxDistance(fruits4ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fruits4ID, avoidFarFruits);
        rmAddObjectDefConstraint(fruits4ID, avoidCloseTapir);
        rmAddObjectDefConstraint(fruits4ID, avoidImpassableLand);
		rmAddObjectDefConstraint(fruits4ID, avoidCloseSilver);
		rmAddObjectDefConstraint(fruits4ID, avoidCloseNuggets);
		rmAddObjectDefConstraint(fruits4ID, playerCloseConstraint);
		rmAddObjectDefConstraint(fruits4ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(fruits4ID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(fruits4ID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(fruits4ID, 0, southIslandID, 2.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(fruits4ID, 0, southIslandID, 1.0*cNumberNonGaiaPlayers);	

/*---------------------------------------------------------------------------------------------------------------*/

        // THE SOUTH ISLAND BERRYBUSH:
        
		fruitsCount = rmRandInt(3,6);

		int fruits5ID=rmCreateObjectDef("The Dry Island Berrybush");
        rmAddObjectDefItem(fruits5ID, "berrybush", fruitsCount, 3.0);
        rmSetObjectDefMinDistance(fruits5ID, 0.0);
        rmSetObjectDefMaxDistance(fruits5ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fruits5ID, avoidFarFruits);
		rmAddObjectDefConstraint(fruits5ID, avoidCloseNatives);
        rmAddObjectDefConstraint(fruits5ID, avoidCloseTapir);
        rmAddObjectDefConstraint(fruits5ID, avoidImpassableLand);
		rmAddObjectDefConstraint(fruits5ID, avoidCloseSilver);
		rmAddObjectDefConstraint(fruits5ID, avoidCloseNuggets);
		rmAddObjectDefConstraint(fruits5ID, playerCloseConstraint);
		rmAddObjectDefConstraint(fruits5ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(fruits5ID, forestCloseConstraint);
		rmSetObjectDefCreateHerd(fruits5ID, true);
		
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(fruits5ID, 0, dryIslandID, 3.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefInArea(fruits5ID, 0, dryIslandID, 1.5*cNumberNonGaiaPlayers);

/*================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE RANDOM TREES:
		
		int randomTreeID=rmCreateObjectDef("The Random Trees");
		rmAddObjectDefItem(randomTreeID, "treeamazon", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseFruits);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTapir);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
        rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
        rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseSilver);
        rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseNuggets);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseNatives);
        rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint);
        rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
        
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FISHES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if(whichVersion == 1)
		
  { 
        // THE FISH SARDINE:
		
		int fishID=rmCreateObjectDef("fish 1");
        rmAddObjectDefItem(fishID, "FishSardine", 2, 5.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);
  }		
		else

  {      // THE FISH BASS:
		
		int fish2ID=rmCreateObjectDef("fish 2");
        rmAddObjectDefItem(fish2ID, "FishBass", 2, 5.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fishVsFish2ID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);
  }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/
 












